<?
/*****************************************************************************
 *   Salary Module (/inc/plugins/myplaza/salary.php)
 *   By Keyvan fakhri shojaie
 *   Last modified: 2008/02/15 by Keyvan
 *   Allow admin to pay salary to moderator
 *****************************************************************************/

if(!defined("IN_MYBB"))die("This file cannot be accessed directly.");

function salary_info(){
	return array(
		"name"			=> "Salary",
		"description"	=> "Pay salary to moderator",
		"website"		=> "http://www.keyvan.ws/projects/mybb/myplaza_modules",
		"author"		=> "Keyvan fakhri shojaie",
		"authorsite"	=> "http://www.keyvan.ws",
		"version"		=> "0.9",
	);
}

function salary_lang(){
	global $mybb,$lang;
	switch($mybb->settings['bblanguage']){
		default:
			$lang->cant_buy_through_plaza = 'You cannot buy this item through the plaza.';
			$lang->item_pay_salary_log = 'Paid %1$s to you for salary';
	}
}

function salary_lang_admin(){
	global $mybb,$lang;
	switch($mybb->settings['bblanguage']){
		default:
			$lang->salary = 'Salary';
			$lang->lastpay = 'Last pay';
			$lang->paycount = 'Payment count';
			$lang->nopayment = 'No any payment yet';
			$lang->item_pay_salary_name = 'Pay salary';
			$lang->item_pay_salary_desc = '';
			$lang->setting_salary_amount = 'Salary amount';
			$lang->setting_salary_amount_desc = 'amount you want to pay to moderator';
			$lang->setting_salary_paycycle = 'Payment cycle in second';
			$lang->setting_salary_paycycle_desc = 'default : monthly';
	}
}

function salary_activate(){
	add_settings(array(
		array(
			"name"			=> 'salary_amount',
			"optionscode"	=> 'text',
			"value"			=> '100.00',
		),
		array(
			"name"			=> 'salary_paycycle',
			"optionscode"	=> 'text',
			"value"			=> 2592000,
		),
		array(
			"name"			=> 'salary_lastpay',
			"optionscode"	=> 'text',
			"value"			=> time(),
		),
		array(
			"name"			=> 'salary_paycount',
			"optionscode"	=> 'text',
			"value"			=> 0,
		)
	));
	myplaza_add_item(array(
		"idname"		=> 'pay_salary',
		"cost"			=> 0,
		"visible" => MY_NO,
		"stockoffset" => 0,
		"showonstats" => MY_NO,
		"infstock" => MY_YES,
		"buylimitamount" => 0,
		"buylimittime" => 0,
		"restockamount" => 0,
		"restocktime" => 0,
		"htmlextra" => '',
	));
	plugins_add_passive_hook('index_end', 'salary_execute');
}

function salary_deactivate(){
	global $db;
	$db->delete_query(MY_TABLE_PREFIX.'settings', 'name IN (\'salary_amount\',\'salary_lastpay\',\'salary_paycount\',\'salary_paycycle\')');
	my_rebuild_settings();
	myplaza_remove_module_items();
	plugins_remove_passive_hooks();
}

function salary_run($item){
	global $lang,$buyRtnMsg;
	$buyRtnMsg = $lang->cant_buy_through_plaza;
	return false;
}

function salary_admin($process){
	global $mybb;
	if($process){
		myplaza_process_settings(array('salary_amount','salary_paycycle'));
	}else{
		global $lang;
		myplaza_langload('salary');
		cpheader_myplaza_module();
		starttable();
		tableheader($lang->salary, "", 2);
		myplaza_generate_settings_code(array('salary_amount','salary_paycycle'));
		makelabelcode($lang->paycount,($mybb->settings['salary_paycount'])?($mybb->settings['salary_paycount']):$lang->nopayment,1);
		if($mybb->settings['salary_paycount']){
			makelabelcode($lang->lastpay,date("Y/m/d h:i:s",$mybb->settings['salary_lastpay']),1);
		}
		endtable();
		cpfooter_myplaza_module();
	}
}

function salary_execute(){
	global $db,$mybb,$lang;
	if(($mybb->settings['salary_lastpay']+$mybb->settings['salary_paycycle'])<time()){
		db_update('users', array(MYPLAZA_MONEY_COLUMN => MYPLAZA_MONEY_COLUMN.'+'.$mybb->settings['salary_amount']),'usergroup IN (3,4,6)',true);
		db_update('settings', array('value' => 'value+1'), 'name=\'salary_paycount\'');
		db_update('settings', array('value' => time()), 'name=\'salary_lastpay\'');
		my_rebuild_settings();
		$row=$db->fetch_array($db->simple_select(TABLE_PREFIX.'plaza_items','*',"idname='pay_salary'"));
		myplaza_langload('salary');
		$db->insert_query(TABLE_PREFIX.'plaza_buylog',array(
			'iid'=>$row['iid'],
			'uid'=>$mybb->user['uid'],
			'description'=>sprintf($lang->item_pay_salary_log,$mybb->settings['salary_amount']),
			'dateline'=>time()
		));
	}
}
?>